///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.AnimationDrivers
{
	public class TranslateFluonGeneratorM2AlongUnrenderedAxes : AnimationDriver<DummyScriptConfiguration>
	{
		public override void AffectFluonConfigurationOfFrame( IFluonContext fx, IFluonConfiguration fcSegment, IFluonConfiguration fcFrame
			, IAnimationThreadConfiguration atc, IAnimationFrameContext afx )
		{
			double progress = AnimationLib.GetProgress( afx.SegmentFrameCount, afx.SegmentFrameIndex, atc.TargetValueBeginning
				, atc.TargetValueEnd, atc.BoundariesAccelerationMode, atc.BoundariesAcceleration );

			fcSegment.FluonGeneratorM2.SetOnAllAxesExcept( progress, fcFrame.AxisIndexForStratumWidth, fcFrame.AxisIndexForStratumHeight );
		}

		public override Mdn AffectStratumPoint( IFluonContext fx, IAnimationThreadConfiguration atc, IAnimationFrameContext afx, Mdn x )
		{
			return x;
		}
	}
}
