///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.DomainProjectors
{
	public class Asymptotic : DomainProjector<DummyScriptConfiguration>
	{
		public override string Description => "xp / (m1 + xp); xp = x ^ s1";

		public override Mdn Project( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			var xp = x.PowDnD1A( fc.DomainProjectorS1 );

			return xp / (fc.DomainProjectorM1 + xp);
		}
	}
}
