///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.DomainProjectors
{
	public class RadiusLoopLnAbs : DomainProjector<DummyScriptConfiguration>
	{
		public override string Description => "x.r = x.r.LoopLnA( s1 )";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.DomainProjectorS1 <= 0 || !fc.DomainProjectorS1.IsInteger() )
				throw new ArgumentException( $"{nameof( RadiusLoopLnAbs )}: DomainProjectorS1 <= 0 || !IsInteger( DomainProjectorS1 )" );
		}

		public override Mdn Project( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			int count = (int)fc.DomainProjectorS1;

			x.RadiusA = x.RadiusA.LoopLnA( count );

			return x;
		}
	}
}
