///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.Contexts;
using Fluogen.Dependz.FluonGenerators;
using Got.Libraries;

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class Oscilloscope : IteratedFluonGeneratorWithSingleDomain<DummyScriptConfiguration, DummyCarryState>
	{
		protected override Mdn InitializeCodomain( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			return fc.FluonGeneratorM1;
		}

		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref DummyCarryState carryState )
		{
			Mdn m2 = fc.FluonGeneratorM2;

			double t0 = 2 * (m2[ 0 ] - y[ 0 ].Cos() * y[ 1 ].Cosh()) - x[ 0 ];
			double t1 = m2[ 1 ] + 2 * y[ 0 ].Sin() * y[ 1 ].Sinh() - x[ 1 ];
			double t2 = m2[ 2 ] + y[ 2 ] - x[ 2 ];

			return new Mdn( new double[] { t0, t1, t2 } );
		}
	}
}
