///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Contexts;
using Fluogen.DeployedScripts.DeployedScripts.Abstracts.FluonGenerators;
using Got.Libraries;

// #abs FluonGenerators\IlluminatedIteratedFluonGenerator

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class MandelbrotIlluminated : IlluminatedIteratedFluonGenerator
	{
		public override string Description => "Illuminated: (y ^ s1 + m1) ^ s2; y0 = m1";

		protected override Mdn InitializeCodomain( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			return fc.FluonGeneratorM1;
		}

		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref DummyCarryState carryState )
		{
			double s1 = fc.FluonGeneratorS1;
			double s2 = fc.FluonGeneratorS2;
			Mdn m1 = x;

			if( s2 == 1 )
			{
				return s1 == 2 && y.Dimensions == 3
					? y.OptimizedSqrAdd3D( m1 )
					: y.OptimizedPowDnD1A( s1 ) + m1;
			}

			return (y.OptimizedPowDnD1A( s1 ) + m1).OptimizedPowDnD1A( s2 );
		}
	}
}
