///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Configuration;
using Fluogen.Dependz.Contexts;
using Fluogen.Dependz.FluonGenerators;
using Got.Libraries;

namespace Fluogen.DeployedScripts.FluonGenerators
{
	public class Population : IteratedFluonGeneratorWithSingleDomain<DummyScriptConfiguration, DummyCarryState>
	{
		public override string Description => "y * (m2 + x) ^ s1; y0 = m1";

		protected override Mdn InitializeCodomain( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x )
		{
			return fc.FluonGeneratorM1;
		}

		protected override Mdn ProcessCodomainIteration( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y
			, ref DummyCarryState carryState )
		{
			double s1 = fc.FluonGeneratorS1;
			Mdn m2 = fc.FluonGeneratorM2;

			return y * (m2 + x).OptimizedPowDnD1A( s1 );
		}
	}
}
