///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.MdnReducers
{
	/// <summary>
	/// Combine with a color extractor like "HslLightnessHue".
	/// </summary>
	public class HslRadiusAngle0 : MdnReducer<DummyScriptConfiguration>
	{
		public override string Description => "l = y.r, h = (y.u[ 0 ] * 2 / pi).FractionalPart( nomirror )";

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp
			, double ev, double evp, ColorDeterminant a, int ri, bool hasEscaped )
		{
			double h = (y.GetAngle( 0 ) / MathLib.Pi2).FractionalPart( false );
			double l = y.RadiusA;

			return new ColorDeterminant( l, h );
		}
	}
}
