///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.MdnReducers
{
	public class ProgressiveSum : MdnReducer<DummyScriptConfiguration>
	{
		public override string Description => "y.r * ((y[ i ] / y.r + s) / 2).SqrtS.Loop( Dimensions ); s0 = 0";

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, Mdn x, Mdn y, Mdn yp
			, double ev, double evp, ColorDeterminant a, int ri, bool hasEscaped )
		{
			return a.Replace( Reduce( y ) );
		}

		private static double Reduce( Mdn y )
		{
			double s = 0;

			for( int i = 0; i < y.Dimensions; i++ )
				s = ((y[ i ] / y.ra + s) / 2).SqrtS();

			return s * y.ra;
		}
	}
}
