///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using ColorManagement.ColorModels;
using ColorManagement.Conversions;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.Palettes
{
	public class TestHclabHue : Palette<DummyScriptConfiguration>
	{
		public override int FullSize => 10000;
		public override int QuickSize => 256;

		protected override void InitializeCache( IFluonConfiguration fc )
		{
		}

		protected override PixelRgbColor ComputeColor( IFluonConfiguration fc, double scalar )
		{
			scalar.ValidateUnitaryScalar();

			var h = scalar;
			var c = 1;
			var l = 0.5;

			var hcl = new Hcl( h, c, l );

			var rgb = Rgb16Bits.FromRgbScalar( HclabConverter.ToRgb( hcl, fc.HclColorSpace, fc.BringHclInGamutOfColorSpace ) );

			return PixelRgbColor.FromRgb16Bits( rgb.R, rgb.G, rgb.B );
		}
	}
}
