///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ScalarReducers
{
	public class FractionalPart : ScalarReducer<DummyScriptConfiguration>
	{
		public override string Description => "(a * s1 + s2).FractionalPart( mirror )";

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			bool mirror = fc.MirrorWhenReducedColorFrequencyAndOffset;

			return a.Replace( (a.Main * fc.ScalarReducerS1 + fc.ScalarReducerS2).FractionalPart( mirror ) );
		}
	}
}
