///////////////////////////////////////////////////////////////////////////////
//
// Developed by Gardener of Thoughts (gardenerofthoughts.org).
// Released under a "Common Sense License".
//
///////////////////////////////////////////////////////////////////////////////

using System;
using Fluogen.Dependz;
using Fluogen.Dependz.Color;
using Fluogen.Dependz.Configuration;
using Got.Libraries;

namespace Fluogen.DeployedScripts.ScalarReducers
{
	public class PhiOutside : ScalarReducer<DummyScriptConfiguration>
	{
		public override string Description => "a.PhiOutside( s1 ); PhiOutside = |x| <= s1 ? (x) : (s1 ^ 2 / x)";

		public override void Validate( IFluonConfiguration fc )
		{
			base.Validate( fc );

			if( fc.ScalarReducerS1.IsZeroWithinEps() )
				throw new ArgumentException( $"{nameof( PhiOutside )}: Limit == 0" );
		}

		public override ColorDeterminant Reduce( IFluonContext fx, IFluonConfiguration fc, IPixelContext px, ColorDeterminant a )
		{
			return a.Replace( a.Main.PhiOutside( fc.ScalarReducerS1 ) );
		}
	}
}
